import greenfoot.*;
/**
 * Element correspondant  une case du damier.
 */
public class Cellule
{
    private int x,y;
       
    public Cellule(int x, int y) {
        this.x = x;
        this.y = y;
    }
    
    // Important pour que deux cellules differentes de memes coordonnees soient considerees comme egales dans le HashSet
    public boolean equals(Object o) {
        if (o == this) {
            return true;
        }
        if (o instanceof Cellule) {
            Cellule c = (Cellule)o;
            return (c.x == x) && (c.y == y);
        } else {
            return false;
        }
    }
    
    // Important pour que deux cellules "egales au sens de equals()" aient le meme hash code (a cause du HashSet)
    public int hashCode() {
        return 8*x+y; // x et y sont entre 0 et 7
    }
    
    public int donneX()
    {
        return x;
    }
    public int donneY()
    {
        return y;
    }
    
    public boolean dansLeMonde()
    {
         return (x>=0 && x<=LeJeu.taille && y>=0 && y<=LeJeu.taille);
    }
    
    public Cellule seDeplacerSelon(Direction direction)
    {
            switch (direction)
     {
       case N:
         return new Cellule(x,y-1);

       case NE: 
         return new Cellule(x+1,y-1);

       case E:
         return new Cellule(x+1,y);

       case SE:
         return new Cellule(x+1,y+1);

       case S:
         return new Cellule(x,y+1);

       case SO:
         return new Cellule(x-1,y+1);

       case O:
         return new Cellule(x-1,y);

       case NO:
         return new Cellule(x-1,y-1);

       default: return null;             
     }
    }
}
