import greenfoot.*;
import java.util.ArrayList;
/**
 * Description d'un coup associ  une position du pion fantme.
 */
public class Coup
{
    private PionFantome pf_;
    private ArrayList<Pion> listePionsARetourner_;
    private Cellule cell_;

    // en cherchant o poser, on testera le coup pour un pion d'essai fantome
    // situ sur chaque cellule de la frontiere (les unes aprs les autres)
    public Coup(PionFantome p)
    {
        this.pf_ = p;
        cell_ = new Cellule(p.getX(),p.getY());
        listePionsARetourner_ = new ArrayList();
    }

    // On parcourt les pions retournables et on les ajoute  la liste au fur et  mesure
    public void miseAJourListe()
    {
        for (Direction d : Direction.values())
        {
            if (pf_.rendreVoisinSelon(d) != null)
            {
                Pion p = pf_.rendreVoisinSelon(d);
                while (p.estRetournableSelon(d,pf_.getCouleur()))
                {
                    listePionsARetourner_.add(p);
                    p = p.rendreVoisinSelon(d);
                }
            }
        }
    }

    public void coupPrevuJoueur()
    {
    }

    public void jouerCoup() //parcourir la liste des pions  retourner et les retourner.
    {
        for(Pion pionARetourner : listePionsARetourner_)
        {
            pionARetourner.seRetourner();
        } 
    }

    public boolean enRegle()//ce coup retourne bien au moins un pion
    {
        boolean condition1 = !(listePionsARetourner_.isEmpty());
        return (condition1 );
    }

    public boolean estAvantageux()
    {
        return pf_.getX()==0 || pf_.getX()==LeJeu.taille || pf_.getY()==0 || pf_.getY()==LeJeu.taille;
    }

    public boolean estDesavantageux()
    {
        return pf_.getX()==1 || pf_.getX()==LeJeu.taille-1 || pf_.getY()==1 || pf_.getY()==LeJeu.taille-1;
    }

    public boolean estUnCoin()
    {
        return ((pf_.getX()==0 || pf_.getX()==LeJeu.taille) && pf_.getY()==0) || ((pf_.getX()==0 || pf_.getX()==LeJeu.taille) && pf_.getY()==LeJeu.taille);
    }

    public ArrayList<Pion> rendreListe()
    {
        return listePionsARetourner_;
    }

    public PionFantome getpf()
    {
        return pf_; 
    }

    public Cellule getCell()
    {
        return cell_;
    }
}