import greenfoot.*;  // (vorld, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.HashSet;
import java.awt.*;
import java.util.ArrayList;
/**
 * Plateau de Jeu
 * 
 * @author (Charlotte Rudnik et Jacques Desprs) 
 * @version (16 juin 2011)
 */

public class LeJeu  extends World
{
    /**
     * Constructeur du plateau de jeu
     */
    public static int taille = 7; // taille damier -1
    private int largeurCellule_ = 60;

    public static Couleur color;  // couleur du tour
    private static PionFantome pionFantome_;
    private static Frontiere frontiere_;

    private Joueur joueur_;
    private Ordinateur ordinateur_;   
    private Score score_;
    private Strategie s;
    private Strategie s2;

    private boolean premierefois = true; // astuce pour ne pas valuer la stratgie en boucle quand c'est le tour du joueur.
    private boolean firsttime = false; // ne pas rpter  l'infini qu'il passe
    private boolean finPartie_= false;
    private boolean joueurPasse = false;
    private boolean ordiPasse = false;          
    private boolean tourJoueur_ = true;

    private int xold=0;
    private int yold=7;
    private int xcurrent=0;
    private int ycurrent=7;

    public void act()
    {
        finPartie_= joueurPasse && ordiPasse;    

        if (!finPartie_) // est ce la fin de la partie ?
        {
            if (tourJoueur_) // dans le cas ou le joueur joue
            {
                if (premierefois) // est ce que le joueur peut jouer? : valuation de la stratgie une fois!
                {
                    s = new Strategie();
                    joueurPasse = s.passe();
                    premierefois = false;
                }

                if (!joueurPasse)
                {            
                    if (firsttime && ordiPasse)
                    {
                        Greenfoot.playSound("cantplay.wav");
                        firsttime=false;
                    }
                    else
                    {
                        pionFantome_.bouger();
                        //sound of moving
                        if(Greenfoot.mouseMoved(null)) 
                        {
                            greenfoot.MouseInfo mouse = Greenfoot.getMouseInfo();            
                            xcurrent=mouse.getX();
                            ycurrent=mouse.getY();
                            if ((xold != xcurrent)||(yold != ycurrent))
                            {
                                xold=xcurrent;
                                yold=ycurrent;
                                Coup cp = new Coup(PionFantome.getPionFantome());
                                if (condition(cp)) // si on clic sur une case vide
                                {GreenfootSound soundy=new GreenfootSound("drop.wav");
                                    soundy.setVolume(70);
                                    soundy.play();}
                            }
                        }
                        // Joue le coup choisi par le joueur
                        if (Greenfoot.mouseClicked(null))
                        {
                            Coup coupJoueur = joueur_.choisirCoup();
                            if (condition(coupJoueur)) // si on clic sur une case vide
                            {
                                jouerUnCoup(coupJoueur); 
                                repaint();
                                donneLaMain();
                                Greenfoot.playSound("boing.wav");
                            }
                        }
                    }
                }
                //  la fin du tour du joueur on change la couleur
                else 
                {
                    donneLaMain();
                }
            }

            else // dans le cas ou l'ordinateur joue.
            {
                // est ce que l'ordi peut jouer? evaluation stratgie.

                s = new Strategie();
                ordiPasse = s.passe();

                // dans le cas o l'ordinateur joue
                if (!ordiPasse)
                {
                    Coup coupOrdi = ordinateur_.choisirCoup(s, null);
                    try { 
                        Thread.sleep(700);} 
                    catch (InterruptedException e) { 
                        return; }
                    testerCoupsJoueur(coupOrdi);//jouerUnCoup(coupOrdi);
                    Greenfoot.playSound("boing.wav");
                }
                else
                {
                    firsttime=true;
                }
                //  la fin de son tour l'ordi donne la main au joueur et change la couleur.
                donneLaMain();
            }
        }
        else //fin de partie
        {
            addObject(new Score(score_), 3, 3);
            repaint();
            if (score_.scoreRouge_>score_.scoreBleu_)
            {
                GreenfootSound soundOne = new GreenfootSound("welldone.wav");  
                GreenfootSound soundTwo = new GreenfootSound("applaus.wav");  
                GreenfootSound soundThree = new GreenfootSound("crush.wav");  
                soundOne.play();  
                while (soundOne.isPlaying()) Greenfoot.delay(1);  
                soundTwo.play();  
                if (score_.scoreRouge_>57)
                {
                    while (soundTwo.isPlaying()) Greenfoot.delay(1);  
                    soundThree.play();
                }
            }
            else
            {
                GreenfootSound soundno=new GreenfootSound("whatashame.wav");
                soundno.play();
                while (soundno.isPlaying()) Greenfoot.delay(1);
                Greenfoot.playSound("evil_laf.wav");}
            Greenfoot.stop();
        }
    }

    public LeJeu()
    {    
        // Cre un "monde", le tableau de jeu, de taille 8x8, avec des cases de taille 60 pixels
        super(8, 8, 60);         

        // impose dans quel ordre on met les lments sur les plateau
        setPaintOrder(Score.class,Pion.class, PionFantome.class);

        //dessine le plateau de jeu
        initialiserFont();

        // Initialise la HashSet des cellules de frontire, une couleur au hasard 
        // pour commencer 
        frontiere_ = Frontiere.getFrontiere();
        color = Couleur.ROUGE;
        //initialiser le jeu avec les 4 premiers pions
        poserPion(new Cellule((taille-1)/2,(taille-1)/2), Couleur.BLEU);
        poserPion(new Cellule((taille+1)/2,(taille+1)/2), Couleur.BLEU);
        poserPion(new Cellule((taille-1)/2,(taille+1)/2), Couleur.ROUGE);
        poserPion(new Cellule((taille+1)/2,(taille-1)/2), Couleur.ROUGE);

        //Cre un joueur, un ordinateur, et un pion fantome,et le score
        joueur_ = new Joueur();
        ordinateur_ = new Ordinateur();
        pionFantome_ = PionFantome.getPionFantome();    
        addObject(pionFantome_, 0,7);
        score_ = new Score();
        Greenfoot.playSound("hello.wav");
    }
    // image d'arriere plan
    public void initialiserFont()
    {
        GreenfootImage plateau = new GreenfootImage(largeurCellule_*8,largeurCellule_*8);
        plateau.setColor(Color.white);
        plateau.fill();
        int i; int j;
        for (i = 0; i<8; i++)
        {
            for(j = 0; j<8;j++)
            {
                if ((i+j)% 2 == 0 )
                {
                    plateau.setColor(Color.white);
                    plateau.fillRect(i*largeurCellule_,j*largeurCellule_,largeurCellule_,largeurCellule_);
                }
                else 
                { 
                    plateau.setColor(Color.black);
                    plateau.fillRect(i*largeurCellule_,j*largeurCellule_,largeurCellule_,largeurCellule_);
                }
            }
        }
        setBackground(plateau);
    }

    public void poserPion(Cellule cellule,Couleur couleur)
    {
        Pion pionB = new Pion(couleur);
        addObject( pionB ,cellule.donneX(), cellule.donneY());

        frontiere_.majFrontiere( pionB );
    }

    public void jouerUnCoup(Coup coup)
    {
        poserPion(coup.getCell(), coup.getpf().getCouleur());
        coup.jouerCoup();

        score_.majScore(coup);
    }

    public void changerDeCouleur()
    {
        pionFantome_.switchCouleur();
        switchCouleur();
    }

    public void switchCouleur() 
    {
        switch(this.color) {
            case BLEU:
            color = Couleur.ROUGE;
            break;
            case ROUGE :
            color = Couleur.BLEU;
            break;
        }
    }

    public boolean condition(Coup coup)
    {
        if (coup != null)
        {
            Boolean bool = getObjectsAt(coup.getpf().getX(), coup.getpf().getY(),Pion.class).isEmpty();
            return bool;
        }
        else return false;
    }

    public void donneLaMain()
    {
        changerDeCouleur();
        tourJoueur_ = !tourJoueur_;

        premierefois = true;  // rinitialise le compteur pour une unique valuation de la stratgie.
    }

    public void testerCoupsJoueur(Coup coupOrdi1)
    {
        pionFantome_.switchCouleur();
        s2=new Strategie();
        joueurPasse=s2.passe();
        ArrayList<Coup> liste0 = s2.rendreListe0();
        ArrayList<Coup> liste1 = s2.rendreListe1();
        pionFantome_.switchCouleur();//rechanger dans l'autre sens la couleur du pion fantome
        if (joueurPasse)
        {
            jouerUnCoup(coupOrdi1);
        }
        else {// il existe au moins 1 coup possible pour le joueur, l'une des 3 listes est non vide
            if (liste0.isEmpty() && liste1.isEmpty())
            {
                jouerUnCoup(coupOrdi1);
            }
            else {
                Coup coupOrdi2=ordinateur_.choisirCoup(s,coupOrdi1);
                jouerUnCoup(coupOrdi2);
            }
        }
    }
}