import greenfoot.*; 
import java.util.HashSet;
import java.util.List;
/**
 * Les pions sont poss sur le plateau de jeu et ont une image, qui peut changer au cours du jeu.
 */
public class Pion  extends Actor
{
    private Couleur couleur_;
    private Cellule celluleAssociee_;
    private HashSet<Cellule> voisinsVides_;

    public Pion(Couleur coul)
    {
        choixCouleur(coul);
        voisinsVides_ = new HashSet();
        celluleAssociee_ = new Cellule(0,0);
    }

    private void choixCouleur(Couleur coul) {
        this.couleur_ = coul;
        switch (coul) {
            case BLEU:
            setImage("button-blue.png");
            break;
            case ROUGE:
            setImage("button-red.png");
            break;
        }
    }

    public void seRetourner()
    {
        switch (couleur_) {
            case BLEU:
            choixCouleur(Couleur.ROUGE);
            break;
            case ROUGE:
            choixCouleur(Couleur.BLEU);
            break;
        }
    }  
  
    // Pour ne garder que les cellules vides, 
    // on regarde les cellules adjacentes  celle qui correspond au Pion observ.
    // Si la liste des pions se situant sur la case adjacente est nulle, 
    // alors on ajoute cette cellule aux voisins vides.
    public HashSet<Cellule> rendreVoisinsVides()
    {
        int x = getX();
        int y = getY();
        celluleAssociee_ = new Cellule(x,y);

        for (Direction d : Direction.values()) 
        {            
            Cellule nouvelleCell = celluleAssociee_.seDeplacerSelon(d);
            int xi = nouvelleCell.donneX();
            int yi = nouvelleCell.donneY();

            if (getWorld().getObjectsAt(xi,yi,null).isEmpty() && nouvelleCell.dansLeMonde())
                voisinsVides_.add(nouvelleCell);
        }
        return voisinsVides_;

    } 
    
    // est retournable selon d et par un pion de couleur c
    public boolean estRetournableSelon(Direction d, Couleur c)
    {
        Cellule celluleAdjacente = celluleAssociee_.seDeplacerSelon(d);
        if (rendreVoisinSelon(d)== null)
            return false;
        else 
        {
            Pion pionAdjacent = rendreVoisinSelon(d);
            if (! (this.couleur_ == c ))
            {
                if (this.couleur_ == pionAdjacent.couleur_)
                    return pionAdjacent.estRetournableSelon(d,c);
                else 
                    return true;
            }
            else return false;
        }
    }
    
    // rend voisins dans une direction, comme pour PionFantome
    public Pion rendreVoisinSelon(Direction d)
    {
        celluleAssociee_ = new Cellule(getX(), getY());
        Cellule celluleAdjacente = celluleAssociee_.seDeplacerSelon(d);
        List liste = getWorld().getObjectsAt(celluleAdjacente.donneX(), celluleAdjacente.donneY(), Pion.class);
        if (liste.isEmpty())
        {
            return null;
        }
        else 
        {
            Pion pionAdjacent =(Pion) liste.get(0);
            return pionAdjacent;
        }
    }
    
    public Cellule getCell()
    {
        return celluleAssociee_;
    }
}
