import greenfoot.*; 
import java.util.List;
/**
 * Un pion imaginaire qui se dplace avec la souris et apparat sur le plateau de jeu.
 */
public class PionFantome  extends Actor
{
    private static PionFantome pionFantome_ = null;
    private Couleur couleur_;

    public final synchronized static PionFantome getPionFantome() 
    {
        if (pionFantome_ == null) 
            pionFantome_ = new PionFantome(Couleur.ROUGE);
            
        return pionFantome_;
    }

    private PionFantome(Couleur coul)
    {
        choixImage(coul);
    }

    public void act() 
    {
        bouger();
    }    

    public void bouger()
    {
        if(Greenfoot.mouseMoved(null)) 
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();            
            int xcurrent=mouse.getX();
            int ycurrent=mouse.getY();
                        setLocation(xcurrent, ycurrent);
        }

    }

    private void choixImage(Couleur coul) {
        this.couleur_ = coul;
        switch (coul) {
            case BLEU:
            GreenfootImage pfb = new GreenfootImage("blue-draught.png");
            pfb.setTransparency( 100 );
            setImage(pfb);
            break;

            case ROUGE:
            GreenfootImage pfr = new GreenfootImage("red-draught.png");
            pfr.setTransparency( 100 );
            setImage(pfr);
            break;
        }
    }

    public void switchCouleur() 
    {
        switch(this.couleur_) {
            case BLEU:
            choixImage(Couleur.ROUGE);
            couleur_=Couleur.ROUGE;
            break;
            case ROUGE :
            choixImage(Couleur.BLEU);
            couleur_=Couleur.BLEU;
            break;
        }

    }

    // rend voisins dans une direction, comme pour Pion
    public Pion rendreVoisinSelon(Direction d)
    {
        Cellule celluleAssociee = new Cellule(getX(), getY());
        Cellule celluleAdjacente = celluleAssociee.seDeplacerSelon(d);
        List liste = getWorld().getObjectsAt(celluleAdjacente.donneX(), celluleAdjacente.donneY(), Pion.class);
        if (liste.isEmpty())
        {
            return null;
        }
        else 
        {
            Pion pionAdjacent =(Pion) liste.get(0);
            return pionAdjacent;
        }
    }

    public Couleur getCouleur()
    {
        return couleur_; // utilise par le coup pour savoir si les pions sont retournables.
    }
}