import greenfoot.*;
import java.util.ArrayList;
/**
 * La manire dont on dcrit une stratgie : sous forme de 3 listes.
 */
public class Strategie
{
    private ArrayList<Coup> liste0;
    private ArrayList<Coup> liste1;
    private ArrayList<Coup> liste2;
    private ArrayList<Coup> liste3;

    public Strategie()
    {
        liste0 = new ArrayList();
        liste1 = new ArrayList();
        liste2 = new ArrayList();
        liste3 = new ArrayList();
        evaluationDuJeu();
    }

    public void evaluationDuJeu()
    {        
        PionFantome pf = PionFantome.getPionFantome();
        Frontiere frontiere = Frontiere.getFrontiere();
        for (Cellule cell : frontiere.rendreFrontiere())
        {
            //on parcourt la frontiere, puis  chaque cellule on ajoute le coup s'il est possible
            pf.setLocation(cell.donneX(),cell.donneY());
            Coup coup= new Coup(pf);
            coup.miseAJourListe(); 
            //tout a dpend de la couleur du pion fantome, 
            //qui elle change  chaque coup : OK.

            if (coup.enRegle())
            {
                if (coup.estUnCoin())
                    liste0.add(coup);
                else if (coup.estAvantageux() && !(coup.estDesavantageux()))
                    liste1.add(coup);
                else if (coup.estDesavantageux())
                    liste3.add(coup);                
                else liste2.add(coup);
            }
        }
    }

    public ArrayList<Coup> rendreListe0()
    {
        return liste0;
    }

    public ArrayList<Coup> rendreListe1()
    {
        return liste1;
    }

    public ArrayList<Coup> rendreListe2()
    {
        return liste2;
    }

    public ArrayList<Coup> rendreListe3()
    {
        return liste3;
    }

    public boolean passe() // Est ce que la personne passe?
    {    
        return (liste0.isEmpty() && liste1.isEmpty() && liste2.isEmpty() && liste3.isEmpty());
    }
}